#ifndef _IMP3_
#define _IMP3_

#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_mixer.h>

#include <taglib/mpegfile.h>
#include <taglib/attachedpictureframe.h>
#include <taglib/id3v2tag.h>

#include "../iGloobus.h"

#define MANAGER_VERSION 1			// TODO: Define here the pluginManager version!!
#define PLUGIN_NAME	 	"iMp3"		// TODO: Define here the plugin Name

using namespace std;

struct Music
{
	Mix_Music *music;
	int audio_rate;
	Uint16 audio_format; 
	int audio_channels;
	int audio_buffers;
};


// ============================ Plugin Class iPhoto ==================================== //

class iMp3 : public iGloobus 	//Class inherited from iGloobus
{	
	private:
	SDL_Surface *					m_photo;
	Music							m_music;
	int								m_coverType;
	
	public: 
	virtual void load();						// Load the mp3
	virtual void init();						// Initialize the plugin
	virtual void end();							// Destroy the plugin
	virtual void render();						// Render function	
	virtual void update(char key[]){};					// Update function
	virtual void get_size(int *w, int *h);		// To know the size of the GL window (on preview)
		
	void		load_texture();				// Private (Load Texture)
	void		init_music();
	void		free_music();		
	
};



// ============================ Class factories======================================== //

extern "C" iGloobus* create() {
	printf("Creating iMp3...\n");
    return new iMp3;
}

extern "C" void destroy(iGloobus* p) {
	printf("Destroying iMp3...\n");
    delete p;
}

extern "C" int getVersion(){			//To save crashes from older versions
	return MANAGER_VERSION;
}

// ============================== REGISTER ============================================ //
extern "C" 
{
   class proxy {
		public:
	   	proxy()
		{
			//TODO: Add here the mime filetypes that plugin supports
			
			plugin_filetype itself = { PLUGIN_NAME, "audio/mpeg",1};		// Initial filetype

			factory[itself.name] = create;		    // Register the plugin
			factoryDestroy[itself.name] = destroy;	// Function for destroy this plugin class			
			pluginVector.push_back(itself);			// Add filetype that plugin reads

		    itself.filetype = "application/ogg";	// Add another extension supported
			pluginVector.push_back(itself);			// Add filetype that plugin reads

	   }
 };
 proxy p;	// When we open the dll with RTLD_NOW it creates p, and in consequence, it registers the plugin 
}

#endif

