#ifndef _IPHOTO_
#define _IPHOTO_

#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_rotozoom.h>

#include "../iGloobus.h"

#define MANAGER_VERSION 1			// TODO: Define here the pluginManager version !!! (In pluginManager.h)
#define PLUGIN_NAME	 	"iPhoto"	// TODO: Define here the plugin Name

using namespace std;

// ============================ Plugin Class iPhoto ==================================== //

class iPhoto : public iGloobus 	//Class inherited from iGloobus
{	
	private:
	SDL_Surface *					m_photo;
	int								m_textureType;
	
	public:
	virtual void load();						// Load the Photo
	virtual void init();						// Initialize the plugin
	virtual void end();							// Destroy the plugin
	virtual void render();						// Render function	
	virtual void update(char key[]){};			// Update function
	virtual void get_size(int *w, int *h);		// To know the size of the GL window (on preview)
		
	void			load_texture();					 // Private (Load Texture)
	void			scale_photo(int wMax, int hMax); // Resize the big photos to use less mem
	
};



// ============================ Class factories======================================== //

extern "C" iGloobus* create() {		
	printf("Creating iPhoto...\n");
    return new iPhoto;
}

extern "C" void destroy(iGloobus* p) {
	printf("Destroying iPhoto...\n");
    delete p;
}

extern "C" int getVersion(){			//To save crashes from older versions
	return MANAGER_VERSION;
}

// ============================== REGISTER ============================================ //
extern "C" 
{
   class proxy {
		public:
	   	proxy()
		{
			//TODO: Add here the mime filetypes that plugin supports
			//plugin_filetype itself = {PLUGIN_NAME,EXTENSION,PRIORITY}
			
			plugin_filetype itself = { PLUGIN_NAME, "image/jpeg",1};		// Initial filetype

			factory[itself.name] = create;		    // Register the plugin
			factoryDestroy[itself.name] = destroy;	// Function for destroy this plugin class
			pluginVector.push_back(itself);			// Add filetype that plugin reads
		    
		    itself.filetype = "image/bmp";			// Add another extension supported
			pluginVector.push_back(itself);			// Add filetype that plugin reads
	   }
 };
 proxy p;	// When we open the dll with RTLD_NOW it creates p, and in consequence, it registers the plugin 
}

#endif

